import {
  IsString,
  IsDateString,
  IsJSON,
  IsNotEmpty,
  Length,
} from 'class-validator';

export class GameDTO {
  @IsString()
  @IsNotEmpty()
  @Length(2, 31)
  name: string;
  @IsString()
  @IsNotEmpty()
  @Length(1, 255)
  desc: string;
  @IsJSON()
  map: JSON;
  @IsDateString()
  @IsNotEmpty()
  startdate: string;
  @IsDateString()
  @IsNotEmpty()
  enddate: string;
}

export class FactionDTO {
  @IsString()
  @IsNotEmpty()
  @Length(2, 15)
  name: string;
  id: string;
  game: GameDTO;
}
